Subject: Re: [bug#32953] [PATCH core-updates-next 0/8] Use GCC7 as the default compiler.

From: Efraim Flashner <[email-masked]>
Date: Sat, 19 Jan 2019 19:09:04 +0200

On Wed, Jan 16, 2019 at 02:53:14PM +0100, Marius Bakke wrote:
> Efraim Flashner <[email-masked]> writes:
> 
> > On Thu, Dec 27, 2018 at 11:59:08AM +0100, Ludovic Courtès wrote:
> >> Hi Marius!
> >> 
> >> Marius Bakke <[email-masked]> skribis:
> >> 
> >> > Marius Bakke <[email-masked]> writes:
> >> >
> >> >> Guix,
> >> >>
> >> >> Here are patches that allow building the world with GCC7.
> >> >>
> >> >> The cross-toolchain and bootstrap tarballs need more work, but native
> >> >> x86_64 at least is largely fine.
> >> >>
> >> >> Marius Bakke (8):
> >> >>   gnu: Remove gcc-for-libstdc++.
> >> >>   gnu: libstdc++-boot0: Improve gcc-wrapper workaround.
> >> >>   gnu: gcc-boot0: Improve gcc-wrapper workarounds.
> >> >>   gnu: Remove duplicate linux-libre-headers package from bootstrap
> >> >>     inputs.
> >> >>   gnu: Use GCC 7 as the default compiler.
> >> >>   gnu: python: Fix FTBFS with GCC >= 6.
> >> >>   gnu: cmake: Try CPATH and C_INCLUDE_PATH when finding system
> >> >>     libraries.
> >> >>   gnu: cppunit: Update to 1.14.0.
> >> >
> >> > I've pushed these to 'wip-gcc7' on Savannah for easier access:
> >> >
> >> > https://git.savannah.gnu.org/cgit/guix.git/log/?h=wip-gcc7
> >> 
> >> I haven’t tested the patch set but I concur with Danny, they LGTM.
> >> 
> >> Now would be a good time to rebase them on ‘core-updates’ and to merge
> >> them so we get enough time to test and fix things.  Would you like to do
> >> that?
> >> 
> >> Thanks!
> >> 
> >> Ludo’.
> >
> > After it's rebased I'll help take a look at the armhf and aarch64
> > boostrap paths to make sure they work.
> 
> I've pushed an updated patch to "wip-gcc7" based on the latest
> 'core-updates'.
> 

I fixed the bootstrapping on aarch64- and armhf-linux.
glibc-final-with-bootstrap-bash was failing to find errno.h and some
other headers, disabling the obsolete rpc support (which wasn't enabled
anywhere else) made it work.

> The cross-compiler toolchain is still broken: it fails to build the very
> last GCC.  For armhf, the build system tries to include
> "gnu/stubs-soft.h" during "./configure" and fails, even though it gets
> "--with-float=hard" as a flag.
> 
> When building the AArch64 cross-compiler, GCC segfaults later in the
> process:
> 
> build/genmatch --gimple ../../gcc-7.4.0/gcc/match.pd > tmp-gimple-match.c
> /gnu/store/vfqvdfdnd8fi9gcx710mpfaf0x4dfd37-bash-minimal-5.0/bin/bash: line 1:  1789 Segmentation fault
> build/genmatch --gimple ../../gcc-7.4.0/gcc/match.pd > tmp-gimple-match.c
> make[2]: *** [Makefile:2460: s-match] Error 139

I'm going to see if I can build hello --target=arm-linux-gnueabihf next
and see how that works.

-- 
Efraim Flashner   <[email-masked]>   אפרים פלשנר
GPG key = A28B F40C 3E55 1372 662D  14F7 41AA E7DC CA3D 8351
Confidentiality cannot be guaranteed on emails sent or received unencrypted